CREATE TABLE wfdataeventaudit (
    _event_type character varying,
    _activity_key character varying,
    _activity_name character varying,
    _time bigint,
    _process_name character varying,
    _idsource character varying,
    _idwfdataeventaudit character varying NOT NULL,
    _process_mgr_version character varying,
    _process_mgr_name character varying,
    _process_key character varying
);

CREATE TABLE wfattribute (
    _description character varying,
    _containertype character varying,
    _id character varying,
    _name character varying,
    _user character varying,
    _accessright character varying,
    _length integer,
    _datatype character varying,
    _value bytea,
    _container character varying,
    _key character varying NOT NULL,
    _isarray boolean
);

CREATE TABLE validatedby (
    _resource_name character varying,
    _idvalidatedby character varying NOT NULL,
    _id character varying,
    _type character varying
);

CREATE TABLE wfassignmenteventaudit (
    _new_resource_name character varying,
    _event_type character varying,
    _activity_key character varying,
    _activity_name character varying,
    _new_resource_key character varying,
    _time bigint,
    _process_name character varying,
    _idwfassignmenteventaudit character varying NOT NULL,
    _old_resource_name character varying,
    _old_resource_key character varying,
    _idsource character varying,
    _process_mgr_version character varying,
    _process_mgr_name character varying,
    _process_key character varying
);

CREATE TABLE wfformalparameter (
    _description character varying,
    _containertype character varying,
    _mandatory boolean,
    _id character varying,
    _name character varying,
    _user character varying,
    _accessright character varying,
    _iomode character varying,
    _length integer,
    _datatype character varying,
    _value bytea,
    _container character varying,
    _key character varying NOT NULL,
    _isarray boolean
);

CREATE TABLE wfresource (
    _resource_name character varying,
    _resource_key character varying NOT NULL,
    _resource_type character varying
);


CREATE TABLE wfactivitymodel (
    _model character varying,
    _ancestor character varying,
    _key character varying NOT NULL,
	Constraint "wfactivitymodel_pkey" Primary Key ("_key")
);


CREATE TABLE wfprocessmodel (
    _model character varying,
    _ancestor character varying,
    _key character varying NOT NULL,
	Constraint "wfprocessmodel_pkey" Primary Key ("_key")
);


CREATE TABLE wfrequester (
    _idwfrequester character varying NOT NULL
);

CREATE TABLE wfinstancemodel (
    _model character varying,
    _ancestor character varying,
    _key character varying NOT NULL
);

CREATE TABLE wfcreateprocesseventaudit (
    _idsource character varying,
    _activity_name character varying,
    _process_key character varying,
    _process_name character varying,
    _activity_key character varying,
    _time bigint,
    _process_mgr_name character varying,
    _event_type character varying,
    _process_mgr_version character varying,
    _idwfcreateprocesseventaudit character varying NOT NULL
);

CREATE TABLE wfstateeventaudit (
    _idwfstateeventaudit character varying NOT NULL,
    _idsource character varying,
    _activity_name character varying,
    _process_key character varying,
    _process_name character varying,
    _activity_key character varying,
    _old_state character varying,
    _time bigint,
    _process_mgr_name character varying,
    _event_type character varying,
    _process_mgr_version character varying,
    _new_state character varying
);

CREATE TABLE wfcreateworkitemeventaudit (
    _idsource character varying,
    _activity_name character varying,
    _process_key character varying,
    _process_name character varying,
    _idwfcreateworkitemeventaudit character varying NOT NULL,
    _activity_key character varying,
    _time bigint,
    _task_id character varying,
    _process_mgr_name character varying,
    _event_type character varying,
    _process_mgr_version character varying,
    _user_id character varying
);

CREATE TABLE wfcreateactivityeventaudit (
    _idsource character varying,
    _activity_name character varying,
    _process_key character varying,
    _process_name character varying,
    _activity_mgr_version character varying,
    _activity_key character varying,
    _time bigint,
    _idwfcreateactivityeventaudit character varying NOT NULL,
    _process_mgr_name character varying,
    _event_type character varying,
    _process_mgr_version character varying,
    _activity_mgr_name character varying
);

CREATE TABLE wftoolagent (
    _toolagenttype character varying,
    _toolagentsessionid character varying NOT NULL,
    _parameters character varying,
    _toolagentcategory character varying
);

CREATE TABLE wfassignment (
    _idwfassignment character varying NOT NULL,
    _idwfresource character varying,
    _idwfactivity character varying,
    _idwftask character varying
);

CREATE TABLE wfactivitymgr (
    _idwfactivitymgr character varying NOT NULL,
	wfactivitymodel__key character varying,
    _model character varying,
    _category character varying,
    _activity_mgr_state integer,
    _name character varying,
    _description character varying,
    _version character varying,
	Constraint "wfactivitymgr_pkey" Primary Key ("_idwfactivitymgr")
);

CREATE TABLE wfactivity (
    _idwfactivity character varying NOT NULL,
	wfactivitymgr__idwfactivitymgr character varying,
	wfprocess__idwfprocess character varying,
    _manager character varying,
    _priority smallint,
    _end_deadline_checked boolean,
    _start_deadline bigint,
    _duration bigint,
    _max_time bigint,
    _idinstance character varying,
    _finish boolean,
    _end_deadline bigint,
    _container character varying,
    _name character varying,
    _description character varying,
    _workflow_state integer,
    _why_not_running integer,
    _min_time bigint,
    _end_time bigint,
    _key character varying,
    _while_open integer,
    _start_time bigint,
    _state character varying,
    _last_state_time bigint,
    _how_closed integer,
    _creation_time bigint,
    _max_time_checked boolean,
    _start_deadline_checked boolean,
	Constraint "wfactivity_pkey" Primary Key ("_idwfactivity")
);

CREATE TABLE wftask (
	wfactivity__idwfactivity character varying,
    _container character varying,
    _idwftask character varying NOT NULL,
    _name character varying,
    _priority smallint,
    _end_deadline_checked boolean,
    _workflow_state integer,
    _description character varying,
    _why_not_running integer,
    _min_time bigint,
    _start_deadline bigint,
    _end_time bigint,
    _start_time bigint,
    _while_open integer,
    _key character varying,
    _duration bigint,
    _max_time bigint,
    _last_state_time bigint,
    _state character varying,
    _how_closed integer,
    _creation_time bigint,
    _max_time_checked boolean,
    _end_deadline bigint,
    _start_deadline_checked boolean
);

CREATE TABLE wfprocess (
    _idwfprocess character varying NOT NULL,
	wfrequester__idwfrequester character varying,
    _requester character varying,
    _priority smallint,
    _end_deadline_checked boolean,
    _start_deadline bigint,
    _duration bigint,
    _max_time bigint,
    _idinstance character varying,
    _end_deadline bigint,
    _name character varying,
    _description character varying,
    _workflow_state integer,
    _why_not_running integer,
    _min_time bigint,
    _end_time bigint,
    _key character varying,
    _while_open integer,
    _start_time bigint,
    _root boolean,
	wfprocessmgr__idwfprocessmgr character varying,
    _state character varying,
    _last_state_time bigint,
    _how_closed integer,
    _creation_time bigint,
    _manager character varying,
    _max_time_checked boolean,
    _start_deadline_checked boolean,
	Constraint "wfprocess_pkey" Primary Key ("_idwfprocess")
);

CREATE TABLE wfprocessmgr (
    _idwfprocessmgr character varying NOT NULL,
	wfprocessmodel__key character varying,
    _model character varying,
    _category character varying,
    _process_mgr_state integer,
    _name character varying,
    _description character varying,
    _version character varying,
	Constraint "wfprocessmgr_pkey" Primary Key ("_idwfprocessmgr")
);

INSERT INTO wfresource (_resource_name, _resource_key, _resource_type) VALUES ('john.steed@mi5.uk', 'jsteed', 'USER');
INSERT INTO wfresource (_resource_name, _resource_key, _resource_type) VALUES ('emma.peel@mi5.uk', 'epeel', 'USER');
INSERT INTO wfresource (_resource_name, _resource_key, _resource_type) VALUES ('tara.king@mi5.uk', 'tking', 'USER');

INSERT INTO wfactivitymodel (_model, _ancestor, _key) VALUES ('<?xml version=''1.0'' encoding=''ISO-8859-1'' ?> <Activity> <Id>START</Id> <Route/></Activity>', NULL, 'start');
INSERT INTO wfactivitymodel (_model, _ancestor, _key) VALUES ('<?xml version=''1.0'' encoding=''ISO-8859-1'' ?> <Activity> <Id>END</Id> <Route/> </Activity>', NULL, 'end');
INSERT INTO wfactivitymodel (_model, _ancestor, _key) VALUES ('<?xml version=''1.0'' encoding=''ISO-8859-1'' ?><Activity><ID>course_demo</ID><Name>Course Activity</Name><Description>Generic model for a course activity</Description><RedefinableHeader><PublicationStatus><UNDER_TEST/></PublicationStatus><Author>Thomas</Author><Version>0.1</Version><Codepage>en</Codepage><Countrykey>UK</Countrykey><Responsibles><Responsible>BOFH</Responsible></Responsibles></RedefinableHeader><DurationUnit><h/></DurationUnit><Created>22 november 2003</Created><Limit>4</Limit><DeadLine><EndDeadLine>D+7</EndDeadLine></DeadLine><Implementation><Tool><Id>course</Id></Tool></Implementation><Group><NO/></Group><Performer><Participant><Id>R1</Id><Name>Student</Name><ParticipantType><ROLE/></ParticipantType></Participant></Performer><StartMode><Manual/></StartMode><FinishMode><Manual/></FinishMode><Priority>5</Priority><FormalParameters></FormalParameters></Activity>', NULL, 'demoCours');
INSERT INTO wfactivitymodel (_model, _ancestor, _key) VALUES ('<?xml version=''1.0'' encoding=''ISO-8859-1'' ?><Activity><ID>demo_exercice</ID><Name>Questions Exercices</Name><Description>Generic model for test activity</Description><RedefinableHeader><PublicationStatus><UNDER_TEST/></PublicationStatus><Author>Thomas</Author><Version>0.1</Version><Codepage>en</Codepage><Countrykey>UK</Countrykey><Responsibles><Responsible>BOFH</Responsible></Responsibles></RedefinableHeader><DurationUnit><h/></DurationUnit><Created>22 november 2003</Created><Limit>4</Limit><DeadLine><EndDeadLine>D+7</EndDeadLine></DeadLine><Implementation><Tool><Id>QCM</Id></Tool></Implementation><Group><NO/></Group><Performer><Participant><Id>R1</Id><Name>Student</Name><ParticipantType><ROLE/></ParticipantType></Participant></Performer><StartMode><Manual/></StartMode><FinishMode><Manual/></FinishMode><Priority>5</Priority><FormalParameters><FormalParameter><DataField><Id>QCMNote</Id><Name>Note QCM</Name><IsArray><FALSE/></IsArray><DataType>int</DataType><AccessRight>rw-r--r--</AccessRight><User>Teacher</User><InitialValue>0</InitialValue><Length>1</Length><Description></Description></DataField><IOMode><OUT/></IOMode><Description> Note du QCM </Description></FormalParameter></FormalParameters></Activity>', NULL, 'demoExercice');
INSERT INTO wfactivitymodel (_model, _ancestor, _key) VALUES ('<?xml version=''1.0'' encoding=''ISO-8859-1'' ?><Activity><ID>demo_correction</ID><Name>Generic correction</Name><Description>Generic model for correction Activity</Description><RedefinableHeader><PublicationStatus><UNDER_TEST/></PublicationStatus><Author>Thomas</Author><Version>0.1</Version><Codepage>en</Codepage><Countrykey>UK</Countrykey><Responsibles><Responsible>BOFH</Responsible></Responsibles></RedefinableHeader><DurationUnit><h/></DurationUnit><Created>22 november 2003</Created><Limit>4</Limit><DeadLine><EndDeadLine>D+7</EndDeadLine></DeadLine><Implementation><No/></Implementation><Group><NO/></Group><Performer><Participant><Id>R1</Id><Name>Teacher</Name><ParticipantType><ROLE/></ParticipantType></Participant></Performer><StartMode><Manual/></StartMode><FinishMode><Manual/></FinishMode><Priority>5</Priority><FormalParameters><FormalParameter><DataField><Id>D1</Id><Name>Exo ? corriger</Name><DataType>int</DataType></DataField><IOMode><IN/></IOMode></FormalParameter></FormalParameters></Activity>', NULL, 'demoCorrection');
INSERT INTO wfactivitymodel (_model, _ancestor, _key) VALUES ('<?xml version=''1.0'' encoding=''ISO-8859-1'' ?><Activity><Id>SUB</Id><Name>Subflow</Name><Description>Subprocess Activity</Description><Implementation><Subflow><Id>juinIndividuel</Id></Subflow></Implementation><Group><YES/></Group><Performer><Participant><Id>PR1</Id><Name>Student</Name><ParticipantType><ROLE/></ParticipantType></Participant></Performer></Activity>', NULL, 'juinSubflow');
INSERT INTO wfactivitymodel (_model, _ancestor, _key) VALUES ('<?xml version=''1.0'' encoding=''ISO-8859-1'' ?><Activity><Id>demo_discussion</Id><Name>Generic discussion</Name><Description>Generic model for discussion activity</Description><RedefinableHeader><PublicationStatus><UNDER_TEST/></PublicationStatus><Author>Thomas</Author><Version>0.1</Version><Codepage>en</Codepage><Countrykey>UK</Countrykey><Responsibles><Responsible>BOFH</Responsible></Responsibles></RedefinableHeader><DurationUnit><h/></DurationUnit><Created>22 november 2003</Created><Limit>4</Limit><DeadLine><EndDeadLine><TimeOption><AdjustedTime><Date><Day>7</Day></Date></AdjustedTime></TimeOption></EndDeadLine></DeadLine><Implementation><Tool><Id>discussion</Id></Tool></Implementation><Group><YES/></Group><Performer><Participant><Id>R1</Id><Name>Student</Name><ParticipantType><ROLE/></ParticipantType></Participant><Participant><Id>R2</Id><Name>Teacher</Name><ParticipantType><ROLE/></ParticipantType></Participant></Performer><StartMode><Manual/></StartMode><FinishMode><Manual/></FinishMode><Priority>5</Priority><FormalParameters></FormalParameters></Activity>', NULL, 'demoDiscussion');

INSERT INTO wfprocessmodel (_model, _ancestor, _key) VALUES ('<WorkflowProcess><Id>p1_demo_complet</Id><Name>Complete Process</Name><ProcessHeader><DurationUnit><D/></DurationUnit><Created>22 november 2003</Created><Description>Complete Process for testing purpose</Description><Priority>2</Priority><Limit>D+14</Limit><ValidFrom>22 november 2003</ValidFrom><ValidTo>30 juin 2002</ValidTo></ProcessHeader><RedefinableHeader><PublicationStatus><UNDER_TEST/></PublicationStatus><Author>Thomas</Author><Version>0.01</Version><Codepage>en</Codepage><Countrykey>UK</Countrykey><Responsibles><Responsible>BOFH</Responsible></Responsibles></RedefinableHeader><Activities><ActivityLink><Id>START</Id><URL>start</URL></ActivityLink><ActivityLink><Id>A1</Id><URL>juinSubflow</URL></ActivityLink><ActivityLink><Id>A2</Id><URL>demoDiscussion</URL></ActivityLink><ActivityLink><Id>END</Id><URL>end</URL></ActivityLink></Activities><Transitions><Transition><Id>T0</Id><From>START</From><To>A1</To><Name>Transition Start</Name><Condition/><Description/></Transition><Transition><Id>T1</Id><From>A1</From><To>A2</To><Name>Cours vers discussion</Name><Description>apr?s le cours et les exo, la discussion</Description></Transition><Transition><Id>T2</Id><From>A2</From><To>END</To><Name>Transition 2</Name><Description>Fin du processus</Description></Transition></Transitions></WorkflowProcess>', NULL, 'juinComplet');
INSERT INTO wfprocessmodel (_model, _ancestor, _key) VALUES ('<?xml version=''1.0'' encoding=''ISO-8859-1'' ?><WorkflowProcess Id=''demoSubflow'' Name=''Individual Process''><ProcessHeader><DurationUnit><D/></DurationUnit><Created>22 november 2003</Created><Description></Description><Priority>2</Priority><Limit>D+14</Limit><ValidFrom>22 november 2003</ValidFrom><ValidTo>30 juin 2002</ValidTo></ProcessHeader><RedefinableHeader><PublicationStatus><UNDER_TEST/></PublicationStatus><Author>Thomas</Author><Version>0.02</Version><Codepage>en</Codepage><Countrykey>UK</Countrykey></RedefinableHeader><Activities><ActivityLink><Id>START</Id><URL>start</URL></ActivityLink><ActivityLink><Id>A1</Id><URL>demoExercice</URL></ActivityLink><ActivityLink><Id>A2</Id><URL>demoCours</URL></ActivityLink><ActivityLink><Id>A3</Id><URL>demoCorrection</URL></ActivityLink><ActivityLink><Id>END</Id><URL>end</URL></ActivityLink></Activities><Transitions><Transition><Id>T0</Id><From>START</From><To>A2</To><Name>transition START</Name><Description>Une transition de d?part du Process</Description></Transition><Transition><Id>T1</Id><From>A2</From><To>A1</To><Name>transition Cours vers Exo</Name><Description>Apr?s le cours les exos</Description></Transition><Transition><Id>T2</Id><From>A1</From><To>A3</To><Name>transition apr?s exos</Name><Description>Apr?s les exos, la correction</Description></Transition><Transition><Id>T3</Id><From>A3</From><To>END</To><Name>transition END</Name><Description>Une transition de fin du Process</Description></Transition></Transitions><DataLinks><DataLink><Id>DL1</Id><DataFrom><ActivityId>A1</ActivityId><DataId>QCMNote</DataId></DataFrom><DataTo><ActivityId>A3</ActivityId><DataId>Result</DataId></DataTo></DataLink></DataLinks></WorkflowProcess>', NULL, 'juinIndividuel');

INSERT INTO wfrequester (_idwfrequester) VALUES ('jsteed');

INSERT INTO wfinstancemodel (_model, _ancestor, _key) VALUES ('<WorkflowInstance><Id>demoInstance</Id><Name>DemoInstance</Name><Description>Instance data for testing purpose</Description><ParticipantAssignment><GeneralParticipantAssignment><ParticipantId>Student</ParticipantId><RealPerformer>epeel</RealPerformer><RealPerformer>tking</RealPerformer></GeneralParticipantAssignment></ParticipantAssignment><ParticipantAssignment><GeneralParticipantAssignment><ParticipantId>Teacher</ParticipantId><RealPerformer>jsteed</RealPerformer></GeneralParticipantAssignment></ParticipantAssignment><ToolAssignment><ToolId>QCM</ToolId><Category>QCM</Category><RealTool><Id>RT1</Id><Type>WEB</Type><Data><URL>http://trg33.univ-lille1.fr:8080/qcm/getQcm</URL></Data><Param><Name>idQcm</Name><Value>qcm1</Value></Param></RealTool></ToolAssignment><ToolAssignment><ToolId>cours</ToolId><Category>COURS</Category><RealTool><Id>RT1</Id><Type>WEB</Type><Data><URL>http://ant.apache.org</URL></Data></RealTool><RealTool><Id>RT2</Id><Type>WEB</Type><Data><URL>http://trg33.univ-lille1.fr/democours1.html</URL></Data></RealTool><RealTool><Id>RT3</Id><Type>WEB</Type><Data><URL>http://trg33.univ-lille1.fr/democours2.html</URL></Data></RealTool></ToolAssignment><ToolAssignment><ToolId>discussion</ToolId><Category>CHAT</Category><RealTool><Id>RT3</Id><Type>WEB</Type><Data><URL>http://trg33.univ-lille1.fr/demodiscussion.html</URL></Data></RealTool></ToolAssignment></WorkflowInstance>', NULL, 'marsInstance');

INSERT INTO wfactivitymgr (_idwfactivitymgr, _model, _category, _activity_mgr_state, _name, _description, _version) VALUES ('end', 'end', 'none', 0, 'end', 'end activity', '1');
INSERT INTO wfactivitymgr (_idwfactivitymgr, _model, _category, _activity_mgr_state, _name, _description, _version) VALUES ('start', 'start', 'none', 0, 'start', 'start activity', '1');
INSERT INTO wfactivitymgr (_idwfactivitymgr, _model, _category, _activity_mgr_state, _name, _description, _version) VALUES ('demoCours', 'demoCours', 'test', 0, 'demoCours', 'consultation de cours', '1');
INSERT INTO wfactivitymgr (_idwfactivitymgr, _model, _category, _activity_mgr_state, _name, _description, _version) VALUES ('demoExercice', 'demoExercice', 'test', 0, 'demoExercice', 'exercice QCM', '1');
INSERT INTO wfactivitymgr (_idwfactivitymgr, _model, _category, _activity_mgr_state, _name, _description, _version) VALUES ('demoCorrection', 'demoCorrection', 'test', 0, 'demoCorrection', 'correction de QCM', '1');
INSERT INTO wfactivitymgr (_idwfactivitymgr, _model, _category, _activity_mgr_state, _name, _description, _version) VALUES ('demoDiscussion', 'demoDiscussion', 'test', 0, 'demoDiscussion', 'activit de dicussion', '1');
INSERT INTO wfactivitymgr (_idwfactivitymgr, _model, _category, _activity_mgr_state, _name, _description, _version) VALUES ('juinSubflow', 'juinSubflow', 'test', 0, 'juinSubflow', 'sous processus test', '1');

INSERT INTO wfprocessmgr (_idwfprocessmgr, _model, _category, _process_mgr_state, _name, _description, _version) VALUES ('juinIndividuel', 'juinIndividuel', 'test', 0, 'juinIndividuel', 'sous processus de test', '1');
INSERT INTO wfprocessmgr (_idwfprocessmgr, _model, _category, _process_mgr_state, _name, _description, _version) VALUES ('juinCompletMgr', 'juinComplet', 'test', 0, 'juinComplet', 'processus de test', '1');

ALTER TABLE ONLY wfdataeventaudit
    ADD CONSTRAINT wfdataeventaudit_pkey PRIMARY KEY (_idwfdataeventaudit);

ALTER TABLE ONLY wfattribute
    ADD CONSTRAINT wfattribute_pkey PRIMARY KEY (_key);

ALTER TABLE ONLY validatedby
    ADD CONSTRAINT validatedby_pkey PRIMARY KEY (_idvalidatedby);

ALTER TABLE ONLY wfassignmenteventaudit
    ADD CONSTRAINT wfassignmenteventaudit_pkey PRIMARY KEY (_idwfassignmenteventaudit);

ALTER TABLE ONLY wfformalparameter
    ADD CONSTRAINT wfformalparameter_pkey PRIMARY KEY (_key);

ALTER TABLE ONLY wfresource
    ADD CONSTRAINT wfresource_pkey PRIMARY KEY (_resource_key);

ALTER TABLE ONLY wfrequester
    ADD CONSTRAINT wfrequester_pkey PRIMARY KEY (_idwfrequester);

ALTER TABLE ONLY wfcreateprocesseventaudit
    ADD CONSTRAINT wfcreateprocesseventaudit_pkey PRIMARY KEY (_idwfcreateprocesseventaudit);

ALTER TABLE ONLY wfstateeventaudit
    ADD CONSTRAINT wfstateeventaudit_pkey PRIMARY KEY (_idwfstateeventaudit);

ALTER TABLE ONLY wfcreateworkitemeventaudit
    ADD CONSTRAINT wfcreateworkitemeventaudit_pkey PRIMARY KEY (_idwfcreateworkitemeventaudit);

ALTER TABLE ONLY wfcreateactivityeventaudit
    ADD CONSTRAINT wfcreateactivityeventaudit_pkey PRIMARY KEY (_idwfcreateactivityeventaudit);

ALTER TABLE ONLY wftoolagent
    ADD CONSTRAINT wftoolagent_pkey PRIMARY KEY (_toolagentsessionid);

ALTER TABLE ONLY wfassignment
    ADD CONSTRAINT wfassignment_pkey PRIMARY KEY (_idwfassignment);

ALTER TABLE ONLY wftask
    ADD CONSTRAINT wftask_pkey PRIMARY KEY (_idwftask);
